<?php
/*
 * Created on 26 nov. 2008 by tl@celeste.fr
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */


require_once 'ZimbraAccount.php';
function array_search_recursive($needle, $haystack, $nodes = array ()) {
	foreach ($haystack as $key1 => $value1) {
		if (is_array($value1))
			$nodes = array_search_recursive($needle, $value1, $nodes);
		elseif (($key1 == $needle) or ($value1 == $needle)) $nodes[] = array (
			$key1 => $value1
		);
	}
	return $nodes;
}

class Zimbra{
	/**
	 * 
	 */
	protected function _getSettings($service, $param) {
		$set = new Settings();
		$toreturn = $set->get($service, $param);
		return $toreturn;
	}
	/**
	 * login (métier) return la class zimbra logué
	 * gestion du "cache"
	 */
	private $zim = null;
	protected function _zimbra_login() {
		global $params, $libelles;
		$zimbraserver = $this->_getSettings($params->ZIMBRASOAP, $params->host);
		;
		$zimbraadminemail = $this->_getSettings($params->ZIMBRASOAP, $params->login);
		;
		$zimbraadminpassword = $this->_getSettings($params->ZIMBRASOAP, $params->password);
		;
		$set = null;
		//Gestion Cache Login
		if ($this->zim == null) {
			$zim = new zimbraAdmin($zimbraserver);
			$zim->zimbra_login($zimbraadminemail, $zimbraadminpassword);
			$this->zim = $zim;
		} else {
			$zim = $this->zim;
		}
		return $zim;
	}
	/**
	 * toto@totodomain.fr return totodomain.fr
	 */
	protected function _get_emaildomain($email) {

		$taille = strlen($email);
		$domain = "";
		$i = 0;
		$oui = false;
		while ($taille != $i) {
			if ($oui)
				$domain .= $email[$i];

			if ($email[$i] == "@")
				$oui = true;

			$i++;
		}

		return $domain;
	}
	/**
	 * retourne une array..!
	 */
	public function zimbra_accounts_isactive_for_a_domain($domain) {
		global $params, $libelles;
		$zim = $this->_zimbra_login();

		$ret = $zim->zimbra_get_all_accounts($domain);

		$tabtoreturn = array ();
		$i = 0;
		if (isset ($ret['ACCOUNT']['NAME'])) {
			$name = $ret['ACCOUNT']['NAME'];
			$status = $libelles->account->active;
			if ($zim->zimbra_is_account_locked($name) == true)
				$status = $libelles->account->locked;
			$tabtoreturn[$i++] = $name . $libelles->sep . " " . $status;
		} else
			foreach ($ret['ACCOUNT'] as $a) {
				$name = $a['NAME'];
				$status = $libelles->account->active;
				if ($zim->zimbra_is_account_locked($name) == true)
					$status = $libelles->account->locked;
				$tabtoreturn[$i++] = $name . $libelles->sep . " " . $status;
			}
		return $tabtoreturn;
	}
	public function _zimbra_getAttributes($attributs, $torecup) {
		$nombre_d_attributs = sizeof($attributs);
		$i = 0;
		$attribut = "";

		while ($nombre_d_attributs != $i) {
			if ($attributs[$i]['N'] == $torecup)
				return $attributs[$i]['DATA'];
			$i++;
		}
		return $attribut; //TEST
	}
	public function zimbra_changestatus_account($login) {
		$zim = $this->_zimbra_login();
		if (!$zim->zimbra_is_account_locked($login)) {
			$zim->zimbra_lock_account($login);
			return 'desactive';
		} else {
			$zim->zimbra_unlock_account($login);
			return 'active';
		}

	}
	public function zimbra_is_account_locked($login){
		$zim = $this->_zimbra_login();
		return $zim->zimbra_is_account_locked($login);
	}
	/**
	 * array d'objects ZimbraAccount
	 */
	public function zimbra_accounts_for_a_domain($domain) {
		global $params, $libelles;

		
		$zim = $this->_zimbra_login();
		$tabtoreturn = array ();
		$ret = $zim->zimbra_get_all_accounts($domain);
		if ($ret == "account.NO_SUCH_DOMAIN") {
			return "account.NO_SUCH_DOMAIN";
		}
		$tabaccount = $ret['ACCOUNT'];

		$nombre_de_compte = sizeof($tabaccount);
		//Gestion du cas avec 1 seul compte
		if ($tabaccount[0]['NAME'] == null && $nombre_de_compte != 0) {
			$tabtoreturn[0] = $this->__formaliseAccountObject($tabaccount);
			

		} else {

			$i = 0;

			while ($nombre_de_compte != $i) {
				$tabtoreturn[$i] = $this->__formaliseAccountObject($tabaccount[$i]);
				$i++;
			}	
			$tabtoreturn  = $this->__sortAccountObject($tabtoreturn);
			
		}
		
		return $tabtoreturn;
	}
	/**
	 * 
	 */
	private function __sortAccountObject($_tabtoreturn,$_critere = 'login') {
		
		$Utils = new Utils;
		
		return $Utils->sortTableOfObjects($_tabtoreturn,$_critere,$sort = 'ASC');	
			
	}
	/**
	 * 
	 */
	private function __formaliseAccountObject($account) {
		global $params, $libelles;
		$zim = $this->_zimbra_login();
		$status = $libelles->account->active;
		if ($zim->zimbra_is_account_locked($account['NAME']) == true)
			$status = $libelles->account->locked;

		$tab_quota = $this->zimbra_get_quota_by_email($account['NAME']);
		
		$_quota_utilise = $tab_quota['USED'];
		$_quota = $this->_zimbra_getAttributes($account['A'], 'zimbraMailQuota');
	
		if ($_quota == ""){
			$quota = 0;
		}else if ($_quota != 0){
			$quota= (float) ($_quota / (1024*1024));
		}
		if ($_quota_utilise == ""){
			$quota_utilise = 0;
		}else if ($_quota_utilise != 0){
			$quota_utilise = (float) ($_quota_utilise / (1024*1024));
		}
		$prenom = $this->_zimbra_getAttributes($account['A'], 'givenName');
		$nom = $this->_zimbra_getAttributes($account['A'], 'sn');

		$alias = $zim->zimbra_get_aliases($account['NAME']);
		if (sizeof($alias) == 0)
			$alias = array (
				0 => ''
			);

		$newaccountobject = new ZimbraAccount($account['NAME'], $account['PASSWORD'], $status, $prenom, $nom, $alias, $quota, $quota_utilise);

		$newaccountobject->set('id', $account['ID']);

		return $newaccountobject;

	}
	public function zimbra_delete_alias($login, $alias) {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_remove_account_alias($login, $alias);
	}
	public function zimbra_add_alias($login, $alias) {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_add_account_alias($login, $alias);
	}
	/**
	 * Renvoie les détails d'un compte
	 * it works!
	 */
	public function zimbra_accounts_details($email) {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_get_account($email);
	}
	/**
	 * Renvoie le status des serveur
	 * it works!
	 */
	public function zimbra_status() {
		global $libelles;
		$zim = $this->_zimbra_login();
		if ($zim == null)
			return array (
				0 => $libelles->zimbra->down
			);

		return $zim->zimbra_get_service_status();
	}

	/**
	 * it works!
	 */
	public function zimbra_get_gal($email) {
		$zim = $this->_zimbra_login();
		$domain = $this->_get_emaildomain($email);
		return $zim->zimbra_search_gal($email, $domain, $type = "all");
	}
	/**
	 * it works
	 */
	public function zimbra_get_all_quota() {
		global $libelles;
		$zim = $this->_zimbra_login();

		$val = $zim->zimbra_get_all_quota_usage(); //retourne tout les quota

		if (!$val) //DEBUG
			return array (
				0 => $libelles->zimbra->error->xml
			);
		return $val;
	}
	public function zimbra_get_quota_by_domain($domain) {
		global $libelles;
		$zim = $this->_zimbra_login();

		$val = $zim->zimbra_get_quota_usage($limit = 0, $offset = 0, $domain, $sort = "", $sortAsc = ""); //retourne tout les quota

		if (!$val) //DEBUG
			return array (
				0 => $libelles->zimbra->error->xml
			);
		return $val;
	}
	/**
	 * ne refait pas d'appel SOAP indefiniment
	 */
	protected static $val = null;
	protected static $email = null;
	public function zimbra_get_quota_by_email($email) {
		global $libelles;

		if ($this->val == null || $this->email != $email) {
			$zim = $this->_zimbra_login();
			$domain = $this->_get_emaildomain($email);

			$this->val = $zim->zimbra_get_quota_usage($limit = 0, $offset = 0, $domain, $sort = "", $sortAsc = ""); //retourne tous les quota du domaine
			$this->email = $email;
		} else {
			// pas de rechargement
		}
		$val = $this->val;
		if (!$val) //DEBUG
			return array (
				0 => $libelles->zimbra->error->xml
			);

		$taille = sizeof($val['ACCOUNT']);
		$i = 0;
		while ($i != $taille) {
			if (trim($val['ACCOUNT'][$i]['NAME']) == trim($email))
				return $val['ACCOUNT'][$i];

			$i++;

		}
		return array (
			0 => $libelles->zimbra->error->accountnotfound . '(' . $email . ')'
		);

	}
	public function zimbra_get_volumes() {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_get_current_volumes();
	}
	/**
	 * it works!
	 */
	public function zimbra_get_all_cos() {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_get_all_cos();
	}
	/**
	 * create 1 account
	 */
	public function zimbra_create_account($email, $password, $firstname, $lastname, $quota = 0) {
		global $libelles;
		$zim = $this->_zimbra_login();
		//DEFINITION DES ATTRIBUTS
		$a = array (
			'displayName' => $firstname . ' ' . $lastname,
			'givenName' => $firstname,
			'sn' => $lastname,
			'zimbraMailCanonicalAddress' => $email,
			'zimbraMailQuota' => $quota
		);

		$val = $zim->zimbra_create_account($email, $password, $a);

		if ($val != false)
			return $val;
		else
			return array (
				0 => $libelles->zimbra->error->accountcreation
			);
	}
	/**
	 * create more accounts by array
	 */
	public function zimbra_create_accounts($magictab) {
		global $libelles;
		$zim = $this->_zimbra_login();
		for($i=0;$i!=sizeof($magictab);$i++){
			$sa = $magictab[$i];
			$verite = $this->zimbra_create_account($sa['compte'],$sa['password'],$sa['nom'],$sa['prenom']);
			if(trim($verite[0]) ==  trim($libelles->zimbra->error->accountcreation))
				echo $sa['compte'].' '.$libelles->zimbra->error->accountcreation.'<br/>';
			else
				echo $sa['compte'].' '.$libelles->zimbra->sucess->accountcreation.'<br/>';
			
		}
		return true;
	}
	/**
	 * 
	 */
	public function zimbra_modify_account($email, $firstname, $lastname, $quota) {
		global $libelles;
		$zim = $this->_zimbra_login();
		//DEFINITION DES ATTRIBUTS
		$a = array (
			'displayName' => $firstname . ' ' . $lastname,
			'givenName' => $firstname,
			'sn' => $lastname,
			'zimbraMailCanonicalAddress' => $email,
			'zimbraMailQuota' => $quota
		);

		$val = $zim->zimbra_modify_account($email, $a);

		if ($val != false)
			return $val;
		else
			return array (
				0 => 'error' . $libelles->zimbra->error->accountmodification
			);
	}
	public function zimbra_set_account_password($name, $password) {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_set_account_password($name, $password);
	}
	public function zimbra_delete_account($name) {

		$zim = $this->_zimbra_login();
		return $zim->zimbra_delete_account($name);
	}
	public function zimbra_modify_account_password($email, $password) {
		global $libelles;
		$zim = $this->_zimbra_login();

		$val = $zim->zimbra_set_account_password($email, $password);

		if ($val != false)
			return $val;
		else
			return array (
				0 => $libelles->zimbra->error->accountmodification
			);
	}
	public function zimbra_modify_account_name($email, $newemail) {
		global $libelles;
		$zim = $this->_zimbra_login();

		$val = $zim->zimbra_rename_account($email, $newemail);

		if ($val != false)
			return $val;
		else
			return array (
				0 => $libelles->zimbra->error->accountmodification
			);
	}
	public function zimbra_get_version_info() {
		$zim = $this->_zimbra_login();
		return $zim->zimbra_get_version_info();
	}
}
 
?>
